CREATE OR REPLACE PROCEDURE CONTABILIZA_NF_SAIDA (
   P_NRLISTA IN LISTA.NRLISTA%TYPE)
IS
   V_VRCONTITEM      FLOAT;
   V_VRCONTITEMNF    FLOAT;
   V_COUNTITEMPROD   FLOAT;
   V_VRCONTITEMTOT   FLOAT;
   V_VRPARTRATE      FLOAT;
   V_VRRATENF        FLOAT;
   V_VRRATEIO        FLOAT;
   V_VRITEMENCA      FLOAT;
   V_VRIMPOSTONF     FLOAT;
   V_DBVRPARTIDAS    FLOAT;
   V_DBVRCONTITEM    FLOAT;
   V_VRPECREPREST    FLOAT; 
   
   
   V_COUNTRATEIO     INT;
   V_COUNTITEMNFORIG INT;
   V_INPARTIDAS      INT;
   V_RATEIO          INT;
   V_NRSEQEXIS       INT;
   V_CONTIMPO        INT;

   
   V_VRFATORMULT   NUMBER;
   V_VRIMPOSRETIDO NUMBER;
   V_VRLANCCORPO   NUMBER;
   V_VRSUBSTRIB    NUMBER;
   V_VRPARTIDAS    NUMBER;    
   V_INRATEIO      NUMBER;
   
   
   V_CDFILICCUST   VARCHAR2(4);
   V_NRLANCCONT    VARCHAR2(12);
   V_PRXNRLANCCONT VARCHAR2(20);
   V_CDCCTBLCORPO  VARCHAR2(20);
   V_CDCCTBLPROD   VARCHAR2(20);
   V_CDHISTPADR    VARCHAR2(04);
   V_CDMODDOCFISC  VARCHAR2(02);
   V_CDFILIORIG    VARCHAR2(04);
   V_NRLANCORIG    VARCHAR2(04);
   V_IDLANCCOME    VARCHAR2(1);
   V_CDCONTCOME    VARCHAR2(21);
   V_CDFILIALITEM   VARCHAR2(4);
   V_NRLANCTONFITEM VARCHAR2(10); 
   V_CDCENTCUST     VARCHAR2(4);
   V_FILIALVRNFORIG VARCHAR2(4);
   V_NRLANCTONF      VARCHAR2(10);
   V_CDCTBLENTRPF    VARCHAR2(20);
   V_CDCTBLSAIDPF    VARCHAR2(20); 
   V_CDIMPOSTRIB     VARCHAR2(2);
   V_NRLANCTONFMOD   VARCHAR2(10);
   V_CDPRODUTO       VARCHAR2(10);
   V_STCONTCTBL      VARCHAR2(20);
   V_STCONTCTBLP     VARCHAR2(20);
   V_DSHISTPADR      VARCHAR2(1000);
   V_CDLOTE          VARCHAR2(20);
   V_NRLANCLOTE      VARCHAR2(6);
   V_DESCITEMCTBLENTR VARCHAR2(20);
   V_DESCITEMCTBLSAID VARCHAR2(20);
   V_CDARVPROD        VARCHAR2(10);
   V_STCONTPASS       VARCHAR2(20);
   V_DSMODDOCFISC     VARCHAR2(100);
   V_CDTPREGFISC      VARCHAR2(20);
   V_CDFILIALMOD      VARCHAR2(04);
   V_CDCTBLFORNCLI    VARCHAR2(20);
   V_STCONTDIFE       VARCHAR2(20);
   V_STCONTPROD       VARCHAR2(20);
   V_CDIMPCARGATRIB   VARCHAR2(20);
   V_CDCCTBLATIV      VARCHAR2(20);
   V_CCTBLPASS        VARCHAR2(20);
   V_CDCCTBLDESP      VARCHAR2(20);
   V_CDTPCTRECEB      VARCHAR2(06);
   V_CDCLASSFINA      VARCHAR2(20);


   V_DTCONTABIL DATE;
   
BEGIN
   EXCLUI_LANCCONTABIL('01',P_NRLISTA);
  
   FOR C_NF IN (
      SELECT
         NF.CDFILIAL, NF.NRLANCTONF, NF.CDEMPRESA,
         NF.IDDOCFINANC, NF.NRNOTAFISC, NF.CDCLIENTE,
         NF.CDFORNECED, NF.NRLANCTBDOC, NF.VRNOTAFISC,
         NF.CDFILIEMIT, NF.CDTIPOOPER, TP.IDCONTABOPER,
         TP.IDOPERDEVONF, NVL(NF.IDORIGDESTNF,'F') AS IDORIGDESTNF, NF.VRPRODUTOS,
         NF.CDFILIRECE, NF.DTENTRSAID, NF.CDINSCESTA,
         NF.DTEMISSAO, C.IDPRIPUBCLIE, NF.IDENTRSAIDOP,
         NVL(FI.CDCENTCUST, EP.CDCENTCUST) AS CDCENTCUST,
         NF.CDSERIEENTR, NF.CDSERIE, NF.IDTPIJURNF, NF.NRINSJURNF, TP.IDDTCONTAB
       FROM NOTAFISCAL NF, FILIAL FI, EMPRESA EP,
            TIPOOPERAC TP, CLIENTE C, LISTA LI
      WHERE NF.CDFILIAL = SUBSTR(LI.CDLISTA,1,4)
        AND NF.NRLANCTONF = SUBSTR(LI.CDLISTA,5,10)
        AND NF.CDEMPRESA = EP.CDEMPRESA
        AND NF.IDENTRSAIDOP = TP.IDENTRSAIDOP
        AND NF.CDTIPOOPER = TP.CDTIPOOPER
        AND NVL(TP.IDCONTABOPER,'S') = 'S'
        AND DECODE(NF.IDENTRSAIDOP,'E', NF.CDFILIRECE, NF.CDFILIEMIT) = FI.CDFILIAL
        AND NF.CDCLIENTE = C.CDCLIENTE(+)
        AND LI.NRLISTA = P_NRLISTA) LOOP

    GERA_LOTECONTABIL(C_NF.CDEMPRESA,'01','',C_NF.CDFILIEMIT,C_NF.DTENTRSAID,C_NF.CDTIPOOPER,'',V_CDLOTE,V_NRLANCLOTE);
     
    IF C_NF.IDCONTABOPER <> 'N' THEN
       
      IF C_NF.IDDTCONTAB IS NULL THEN
         IF C_NF.IDORIGDESTNF = 'L' THEN
            V_DTCONTABIL := C_NF.DTENTRSAID;
         ELSE IF C_NF.DTEMISSAO IS NOT NULL THEN
                 V_DTCONTABIL := C_NF.DTEMISSAO;
              ELSE
                 V_DTCONTABIL := C_NF.DTENTRSAID;
              END IF;
         END IF;     
      ELSE
         IF C_NF.IDDTCONTAB = 'M' THEN
            V_DTCONTABIL := C_NF.DTENTRSAID;
         ELSE IF C_NF.DTEMISSAO IS NOT NULL THEN
                 V_DTCONTABIL := C_NF.DTEMISSAO;
              ELSE
                 V_DTCONTABIL := C_NF.DTENTRSAID;
              END IF;
         END IF;
      END IF;   
      
      BEGIN
        SELECT C.CDCTBLFORNCLI
          INTO V_CDCTBLFORNCLI    
          FROM CTBPRDTPOPER C,
              (SELECT MAX(PR.CDARVPROD) CDARVPROD
                 FROM CTBPRDTPOPER A, PRODUTO P, ITEMPRODUTO I, PRODUTO PR
                WHERE IDENTRSAIDOP = 'E'   AND
                      CDTIPOOPER   = C_NF.CDTIPOOPER   AND
                      P.CDARVPROD  LIKE  PR.CDARVPROD || '%'    AND
                      P.CDPRODUTO  =  I.CDPRODUTO    AND
                      I.CDFILIAL  = C_NF.CDFILIAL      AND
                      I.NRLANCTONF = C_NF.NRLANCTONF      AND
                      A.CDCTBLFORNCLI IS NOT NULL     AND
                      A.CDPRODUTO = PR.CDPRODUTO) PR,
               PRODUTO P
         WHERE IDENTRSAIDOP = 'E'   AND
               CDTIPOOPER   = C_NF.CDTIPOOPER   AND
               C.CDPRODUTO  = P.CDPRODUTO     AND
               P.CDARVPROD = PR.CDARVPROD;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
         V_CDCTBLFORNCLI := NULL;
      END;
            
      IF (C_NF.IDORIGDESTNF IS NULL) OR (C_NF.IDORIGDESTNF = 'C') THEN
         V_IDLANCCOME := 'C';
         V_CDCONTCOME := C_NF.CDCLIENTE; 
      /* guilherme */
         
         CONTCTBL_CLIENTE(C_NF.CDEMPRESA, C_NF.CDTIPOOPER, 'S', C_NF.CDFILIEMIT, C_NF.CDCLIENTE, V_STCONTCTBL, V_STCONTCTBLP, V_STCONTDIFE, V_CDHISTPADR);

      ELSIF C_NF.IDORIGDESTNF = 'F' THEN
         V_IDLANCCOME := 'F';
         V_CDCONTCOME := C_NF.CDFORNECED;
      /* GUILHERME */
      
         CONTCTBL_FORNECEDOR(C_NF.CDEMPRESA, C_NF.CDTIPOOPER, 'S', C_NF.CDFILIEMIT, C_NF.CDFORNECED, V_STCONTCTBL, V_STCONTCTBLP, V_STCONTDIFE, V_CDHISTPADR);
    
      ELSIF C_NF.IDORIGDESTNF = 'L' THEN
         V_IDLANCCOME := ' ';
         V_CDCONTCOME := '';
        /* GUILHERME */
         
         CONTCTBL_FILIAL(C_NF.CDEMPRESA, C_NF.CDTIPOOPER, 'S', C_NF.CDFILIEMIT, V_STCONTCTBL, V_STCONTCTBLP, V_STCONTDIFE, V_CDHISTPADR); 
        
      END IF;
      
      IF V_CDCTBLFORNCLI IS NOT NULL THEN
         V_STCONTCTBL := V_CDCTBLFORNCLI;
      END IF;   

      /*LANCAMENTOS DE DEBITO*/
      
      BEGIN
        SELECT NVL(ROUND(SUM(VRIMPOSTONF),2),0)
          INTO V_VRIMPOSRETIDO
          FROM IMPOSTONF INF, IMPOSTO I
         WHERE CDFILIAL = C_NF.CDFILIAL 
           AND NRLANCTONF = C_NF.NRLANCTONF 
           AND INF.CDIMPOSTO = I.CDIMPOSTO
           AND I.IDTRATIMPO = 'R'
           AND I.IDTIPCONTAB = 'D'
           AND (((IDIMPORECUP = 'S') AND ((CDCCTBLATIV IS NULL) OR (CDFISCALNF <> '1'))) OR (IDIMPORECUP <> 'S'));
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
         V_VRIMPOSRETIDO := 0;
      END;   
        
      V_VRLANCCORPO := - (C_NF.VRNOTAFISC - V_VRIMPOSRETIDO);

      /*MONTA HISTORICO PADRAO*/
      MONTA_HISTORICO(C_NF.CDFILIAL,C_NF.NRLANCTONF,V_CDHISTPADR,C_NF.NRNOTAFISC,C_NF.DTEMISSAO, '00', '', V_DSHISTPADR);
      
      /*INSERE PARTIDA DE CREDITO*/
      NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, V_STCONTCTBL, V_CDHISTPADR,
                   V_DSHISTPADR, ROUND(V_VRLANCCORPO,2), V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');
         
      /*INSERE RATEIO*/              
      RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,C_NF.DTENTRSAID,V_NRLANCLOTE,C_NF.CDFILIEMIT,
                     C_NF.CDCENTCUST, V_VRLANCCORPO);
                     
      /* LANAMENTOS DE CREDITO */               

      FOR IE IN (
         SELECT NVL(VRITEMENCA,0) AS VRITEMENCA, CDCTBLENTREN, CDCTBLSAIDEN, IDENCARGO
           FROM ITEMENCARGO IE, ENCARGO E
          WHERE IE.CDFILIAL = C_NF.CDFILIAL
            AND IE.NRLANCTONF = C_NF.NRLANCTONF
            AND IE.CDENCARGO = E.CDENCARGO
            AND IE.VRITEMENCA > 0
            AND E.IDENCARGO IN ('A','D')
            AND (DECODE('E', 'E', CDCTBLENTREN, CDCTBLSAIDEN) IS  NOT NULL)) LOOP

         IF IE.IDENCARGO = 'A' THEN
            V_VRLANCCORPO := V_VRLANCCORPO + (IE.VRITEMENCA);
         ELSE
            V_VRLANCCORPO := V_VRLANCCORPO - (IE.VRITEMENCA);
         END IF;
      END LOOP;

      FOR IP IN (
         SELECT A.CDIMPOSTO, NVL(ROUND(SUM(A.VRIMPOSTONF),2),0) AS VRIMPOSTONF,
                A.IDTRATIMPO, A.IDIMPORECUP, A.IDACRPRODENTRNF, A.IDTRIMPOSTNF,
                NVL(SUM(VRIMPCARGATRIBI),0) AS VRIMPCARGATRIBI,
                MAX(CDCONTATIV) AS CDCONTATIV, MAX(CDCONTPASS)  AS CDCCONTPASS,
                MAX(CDCONTDESP)  AS CDCONTDESP
           FROM (SELECT INF.CDIMPOSTO, VRIMPOSTONF, VRIMPCARGATRIBI, NVL(IDACRPRODENTRNF, 'N') IDACRPRODENTRNF,
                        PF.IDCARACFIS, I.IDIMPORECUP, I.IDTRATIMPO, INF.CDFISCALNF, INF.IDTRIMPOSTNF,
                        CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'A', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCONTATIV,
                        CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'P', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCONTPASS,
                        CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'D', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCONTDESP
                   FROM IMPOSTONF INF, IMPOSTO I, NOTAFISCAL NF, PARAMFILIAL PF
                  WHERE NF.CDFILIAL     = C_NF.CDFILIAL
                    AND NF.NRLANCTONF   = C_NF.NRLANCTONF
                    AND PF.CDFILIAL(+)  = NF.CDFILIRECE
                    AND INF.CDFILIAL    = C_NF.CDFILIAL
                    AND INF.NRLANCTONF  = C_NF.NRLANCTONF
                    AND INF.CDIMPOSTO   = I.CDIMPOSTO
                    AND INF.VRIMPOSTONF > 0
                    AND INF.IDIMPOSTONF IN ('1','4')
                    AND I.IDTIPCONTAB  = 'D') A
          WHERE ((((A.IDIMPORECUP  = 'S' AND A.CDFISCALNF = '1' AND NVL(A.IDCARACFIS,'C') = 'C') OR (A.IDCARACFIS = 'A')) AND (A.CDCONTATIV IS NOT NULL)) OR
                 ((A.IDIMPORECUP <> 'S') AND (A.CDCONTPASS IS NOT NULL)))
          GROUP BY A.CDIMPOSTO, A.IDTRATIMPO,  A.IDIMPORECUP, A.IDACRPRODENTRNF, A.IDTRIMPOSTNF) LOOP

           BEGIN
              SELECT NVL(CDIMPCARGATRIB,'0'), NVL(CDCCTBLATIV,'0'), NVL(CDCCTBLPASS,'0'), NVL(CDCCTBLDESP,'0')
                INTO V_CDIMPCARGATRIB, V_CDCCTBLATIV, V_CCTBLPASS, V_CDCCTBLDESP
                FROM IMPOSTO
               WHERE CDIMPOSTO = IP.CDIMPOSTO;
           EXCEPTION
           WHEN NO_DATA_FOUND THEN
              V_CDIMPCARGATRIB := '0';
              V_CDCCTBLATIV    := '0';
              V_CCTBLPASS      := '0';
              V_CDCCTBLDESP    := '0';
           END;

           IF IP.VRIMPOSTONF > 0 THEN
              IF C_NF.IDOPERDEVONF <> 'S' THEN
                 SELECT MAX(CDIMPOSTO) AS CDIMPOSTRIB
                   INTO V_CDIMPOSTRIB
                   FROM IMPOSTO
                  WHERE CDIMPOSTRIB = IP.CDIMPOSTO;

                  IF V_CDIMPOSTRIB IS NOT NULL THEN
                     IF IP.IDTRATIMPO = 'R' THEN
                        V_VRLANCCORPO := V_VRLANCCORPO - ROUND(IP.VRIMPOSTONF,2);
                     ELSE IF (IP.IDTRATIMPO = 'V') AND (C_NF.IDORIGDESTNF = 'L') THEN
                             V_VRLANCCORPO := V_VRLANCCORPO + ROUND(IP.VRIMPOSTONF,2);
                          END IF;
                     END IF;
                  END IF;
              ELSE
                 V_VRLANCCORPO := V_VRLANCCORPO + ROUND(IP.VRIMPOSTONF,2);
              END IF;
           END IF;
      END LOOP;

      /* DESCITEM */
      BEGIN
         SELECT NVL(ROUND(SUM(VRDESCITEM),2),0) AS VRITEMENCA, CDCTBLENTREN, CDCTBLSAIDEN
           INTO V_VRITEMENCA, V_DESCITEMCTBLENTR, V_DESCITEMCTBLSAID
           FROM ITEMPRODUTO I,
                (SELECT CDCONTDITEN AS CDCTBLENTREN,
                        CDCONTDITSA AS CDCTBLSAIDEN
                   FROM PARAMCTBL
                  WHERE DECODE('S', 'E', CDCONTDITEN, CDCONTDITSA) IS NOT NULL) E
          WHERE I.CDFILIAL   = C_NF.CDFILIAL
            AND I.NRLANCTONF = C_NF.NRLANCTONF
          GROUP BY CDCTBLENTREN, CDCTBLSAIDEN
         HAVING ROUND(SUM(VRDESCITEM),2) > 0;
      EXCEPTION
         WHEN NO_DATA_FOUND THEN
         V_VRITEMENCA:= 0;
         V_DESCITEMCTBLENTR := NULL;
         V_DESCITEMCTBLSAID := NULL;
      END;

      V_DBVRPARTIDAS := 0;
      
      BEGIN
        SELECT MAX(IT.NRSEQITPROD)
          INTO V_NRSEQEXIS
          FROM ITEMPRODUTO IT, PRODUTO P, PRODUTO PR
         WHERE CDFILIAL     = C_NF.CDFILIAL     
           AND NRLANCTONF   = C_NF.NRLANCTONF   
           AND VRCONTITEM   > 0             
           AND (P.CDARVPROD = (SELECT MAX(CDARVPROD)
                                 FROM PRODUTO C
                                WHERE (INSTR(PR.CDARVPROD,RTRIM(C.CDARVPROD)) = 1) 
                                  AND NOT (DECODE(C_NF.IDENTRSAIDOP, 'E', CDCTBLENTRPR, CDCTBLSAIDPR) IS NULL)) OR
                IT.CDPRODUTO = P.CDPRODUTO) 
           AND IT.CDPRODUTO = PR.CDPRODUTO;
      EXCEPTION
        WHEN NO_DATA_FOUND THEN
          V_NRSEQEXIS := NULL;
      END;
      
      IF V_NRSEQEXIS IS NOT NULL THEN
      
         FOR C_ITEMPRODUTO IN (
              SELECT IT.NRSEQITPROD, IT.CDPRODUTO,
                     ROUND(VRCONTITEM,2) VRCONTITEM,
                     MAX(P.CDCTBLENTRPR) AS CDCTBLENTRPR,
                     MAX(P.CDCTBLSAIDPR) AS CDCTBLSAIDPR,
                     ROUND(VRDESCITEM,2) VRDESCITEM
                FROM ITEMPRODUTO IT, PRODUTO P, PRODUTO PR
               WHERE CDFILIAL = C_NF.CDFILIAL
                 AND NRLANCTONF = C_NF.NRLANCTONF
                 AND VRCONTITEM > 0
                 AND (P.CDARVPROD = (SELECT MAX(CDARVPROD)
                                       FROM  PRODUTO C
                                      WHERE (INSTR(PR.CDARVPROD,RTRIM(C.CDARVPROD)) = 1)
                                        AND  NOT (DECODE('S', 'E', CDCTBLENTRPR, CDCTBLSAIDPR) IS NULL)) OR IT.CDPRODUTO = P.CDPRODUTO) AND
                     IT.CDPRODUTO = PR.CDPRODUTO
               GROUP BY IT.NRSEQITPROD, IT.CDPRODUTO, VRCONTITEM, VRDESCITEM) LOOP
            
               V_INPARTIDAS := 1;
             
               IF (C_NF.IDPRIPUBCLIE = 'B') AND (V_STCONTDIFE IS NOT NULL) THEN
                   V_STCONTPROD := V_STCONTDIFE;
               ELSE
                  /* PRODUTO */
                  BEGIN
                   SELECT P.CDARVPROD,P.CDPRODUTO, NVL(NVL(NVL(PR.CDCCUSTENTRF,P.CDCCUSTENTR),F.CDCENTCUST),E.CDCENTCUST) CDCENTCUST
                     INTO V_CDARVPROD, V_CDPRODUTO, V_CDCENTCUST
                     FROM FILIAL F, NOTAFISCAL N, EMPRESA E,
                          PRODUTO P, PRODFILI PR
                    WHERE (P.CDPRODUTO     = C_ITEMPRODUTO.CDPRODUTO)  
                      AND (PR.CDPRODUTO(+) =  P.CDPRODUTO)
                      AND (PR.CDFILIAL(+)  = C_NF.CDFILIEMIT )
                      AND (F.CDFILIAL      = C_NF.CDFILIEMIT )
                      AND (N.CDFILIAL      = C_NF.CDFILIAL)
                      AND (N.NRLANCTONF    = C_NF.NRLANCTONF)
                      AND (N.CDEMPRESA     = C_NF.CDEMPRESA)
                      AND (N.CDEMPRESA     = E.CDEMPRESA);
                  EXCEPTION
                    WHEN NO_DATA_FOUND THEN
                         V_CDARVPROD := NULL;
                         V_CDCENTCUST := NULL;
                  END;
               
                  /*ContProdTp*/
                  BEGIN 
                   SELECT C.CDCTBLPRODTO
                     INTO V_CDCCTBLPROD 
                     FROM CTBPRDTPOPER C,
                          (SELECT MAX(P.CDARVPROD) CDARVPROD
                             FROM CTBPRDTPOPER A, PRODUTO P
                            WHERE IDENTRSAIDOP = 'E'   
                              AND CDTIPOOPER   = C_NF.CDTIPOOPER
                              AND P.CDPRODUTO  =  A.CDPRODUTO
                              AND (INSTR(V_CDARVPROD, RTRIM(P.CDARVPROD)) = 1)
                              AND A.CDCTBLPRODTO IS NOT NULL) PR,
                          PRODUTO P
                    WHERE IDENTRSAIDOP = 'E'   
                      AND CDTIPOOPER   = C_NF.CDTIPOOPER
                      AND C.CDPRODUTO  = P.CDPRODUTO
                      AND P.CDARVPROD = PR.CDARVPROD; 
                  EXCEPTION
                    WHEN NO_DATA_FOUND THEN
                         V_CDCCTBLPROD := NULL;
                  END;
                       
                  V_STCONTPROD := V_CDCCTBLPROD;

                  IF V_STCONTPROD IS NOT NULL THEN
                     V_STCONTPROD := V_STCONTCTBLP;
                  END IF;   
               END IF;
            
               IF V_STCONTPROD IS NULL THEN
                  BEGIN 
                   SELECT MAX(CDCTBLENTRPF) AS CDCTBLENTRPF,
                          MAX(CDCTBLSAIDPF) AS CDCTBLSAIDPF
                     INTO V_CDCTBLENTRPF, V_CDCTBLSAIDPF
                     FROM PRODFILI PF, PRODUTO P
                    WHERE CDFILIAL      = C_NF.CDFILIEMIT   
                      AND PF.CDPRODUTO  = V_CDPRODUTO
                      AND (P.CDPRODUTO IN (SELECT MAX(CDPRODUTO)
                                             FROM  PRODUTO C
                                            WHERE (INSTR(PF.CDPRODUTO,RTRIM(C.CDPRODUTO)) = 1) AND
                                              NOT (DECODE('S', 'E', CDCTBLENTRPF, CDCTBLSAIDPF) IS NULL)) 
                       OR PF.CDPRODUTO = P.CDPRODUTO);
                  EXCEPTION
                    WHEN NO_DATA_FOUND THEN
                      V_CDCTBLENTRPF := NULL;
                      V_CDCTBLSAIDPF := NULL;
                  END;
                  V_STCONTPROD := V_CDCTBLSAIDPF;
               END IF;

                 IF V_STCONTPROD IS NULL THEN
                    V_STCONTPROD := C_ITEMPRODUTO.CDCTBLSAIDPR;
                 END IF;

                 IF C_ITEMPRODUTO.VRCONTITEM > 0 THEN
                     V_DBVRCONTITEM := C_ITEMPRODUTO.VRCONTITEM;
                     V_DBVRPARTIDAS := V_DBVRPARTIDAS + C_ITEMPRODUTO.VRCONTITEM;
                  
                     BEGIN
                      SELECT COUNT(DISTINCT NRSEQITPROD)
                        INTO V_COUNTITEMNFORIG
                        FROM ITEMPRODUTO I, PRODUTO P, PRODUTO PR, ITEMNOTAFISC IT, NOTAFISCAL N
                       WHERE IT.CDFILIAL = I.CDFILIAL
                         AND IT.NRLANCTONF = I.NRLANCTONF
                         AND N.CDFILIAL = I.CDFILIAL
                         AND N.NRLANCTONF = I.NRLANCTONF
                         AND N.IDENTRSAIDOP = 'S'
                         AND IT.CDFILIALIT     = C_NF.CDFILIAL
                         AND IT.NRLANCTONFIT   = C_NF.NRLANCTONF
                         AND P.CDCTBLENTRPR IS NOT NULL
                         AND VRCONTITEM   > 0
                         AND (P.CDARVPROD = (SELECT MAX(CDARVPROD)
                                               FROM PRODUTO C
                                              WHERE (INSTR(PR.CDARVPROD,RTRIM(C.CDARVPROD)) = 1)
                                                AND NOT (CDCTBLENTRPR IS NULL)) OR (I.CDPRODUTO = P.CDPRODUTO))
                         AND I.CDPRODUTO = PR.CDPRODUTO
                       GROUP BY I.CDFILIAL, I.NRLANCTONF, I.NRSEQITPROD, I.CDPRODUTO, P.CDCTBLENTRPR;
                     EXCEPTION
                      WHEN NO_DATA_FOUND THEN
                       V_COUNTITEMNFORIG := 0;
                     END;

                     IF V_INPARTIDAS = V_COUNTITEMNFORIG THEN
                        IF (ABS(ROUND(ABS(V_DBVRPARTIDAS),2) - ROUND(ABS(V_VRLANCCORPO),2)) <= 0.1) AND
                           (ROUND(ABS(V_DBVRPARTIDAS),2) <> ROUND(ABS(V_VRLANCCORPO),2)) THEN 
                            V_DBVRCONTITEM := ABS(V_DBVRCONTITEM - (V_DBVRPARTIDAS + V_VRLANCCORPO));
                        END IF;
                     END IF;
                  
                     IF ABS(V_DBVRCONTITEM) > 0 THEN
                        NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, V_STCONTPROD, V_CDHISTPADR, V_DSHISTPADR, V_DBVRCONTITEM,
                                     V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S'); 
                                  
                        BEGIN
                         SELECT CDFILICCUST
                           INTO V_CDFILICCUST
                           FROM RATEIONF
                          WHERE CDFILIAL = C_NF.CDFILIAL
                            AND NRLANCTONF = C_NF.NRLANCTONF 
                            AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                        EXCEPTION
                         WHEN NO_DATA_FOUND THEN
                          V_CDFILICCUST := NULL;
                        END;         
                     
                        V_VRPARTRATE := 0;
                              
                        IF V_CDFILICCUST IS NOT NULL THEN
                           V_RATEIO := 1;

                            FOR C_RATEIONF IN (
                             SELECT CDFILICCUST, CDCENTCUSNF, 
                                    NVL(ROUND(VRRATENF,2),0) AS VRRATENF
                               FROM RATEIONF
                              WHERE CDFILIAL    = C_NF.CDFILIAL
                                AND NRLANCTONF  = C_NF.NRLANCTONF  
                                AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD) LOOP
                                       
                             V_VRRATEIO := C_RATEIONF.VRRATENF;
                             V_VRPARTRATE := V_VRPARTRATE + (C_RATEIONF.VRRATENF);
                                     
                              BEGIN  
                               SELECT COUNT(*)
                                 INTO V_COUNTRATEIO
                                 FROM RATEIONF
                                WHERE CDFILIAL = C_NF.CDFILIAL
                                  AND NRLANCTONF = C_NF.NRLANCTONF
                                  AND NRSEQITPROD = C_ITEMPRODUTO.NRSEQITPROD;
                              EXCEPTION
                               WHEN NO_DATA_FOUND THEN
                                V_COUNTRATEIO := 0;
                              END;
                                                      
                              IF V_RATEIO = V_COUNTRATEIO THEN
                                 IF (Abs(Round(ABS(V_VRPARTRATE),2) - Round(ABS(V_DBVRCONTITEM),2)) <= 0.1) and
                                    (Round(ABS(V_VRPARTRATE),2) <> Round(ABS(V_DBVRCONTITEM),2)) THEN
                                    V_VRRATEIO := V_VRRATEIO + (V_VRPARTRATE - V_DBVRCONTITEM);
                                 END IF;
                              END IF;

                              RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_RATEIONF.CDFILICCUST, C_RATEIONF.CDCENTCUSNF, V_VRRATEIO);
                          
                              V_RATEIO := V_RATEIO + 1;
                            END LOOP;  
                        ELSE
                          RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, V_CDCENTCUST, V_DBVRCONTITEM);
                        END IF;
                     END IF;   
                 END IF;
               
                IF (C_ITEMPRODUTO.VRDESCITEM > 0) AND (V_DESCITEMCTBLSAID IS NOT NULL) THEN
                    NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, V_STCONTPROD, V_CDHISTPADR, V_DSHISTPADR, C_ITEMPRODUTO.VRDESCITEM,
                                 V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');
                    RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, V_CDCENTCUST, C_ITEMPRODUTO.VRDESCITEM);

                    V_INPARTIDAS := V_INPARTIDAS + 1;

                    V_STCONTPROD := '';
                END IF;
         END LOOP;
      ELSE
                IF ABS(V_VRLANCCORPO) > 0 THEN
                   V_STCONTPROD := V_STCONTCTBLP;

                   NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, V_STCONTPROD, V_CDHISTPADR, V_DSHISTPADR, V_VRLANCCORPO,
                                V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                   RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, V_CDCENTCUST, V_VRLANCCORPO);
                END IF;
      END IF;

      FOR C_ITEMENCARGO IN(
         SELECT VRITEMENCA, CDCTBLENTREN, CDCTBLSAIDEN, IDENCARGO
           FROM ITEMENCARGO IE, ENCARGO E
          WHERE IE.CDFILIAL   = C_NF.CDFILIAL
            AND IE.NRLANCTONF = C_NF.NRLANCTONF
            AND IE.CDENCARGO  = E.CDENCARGO
            AND IE.VRITEMENCA > 0
            AND E.IDENCARGO IN ('A','D')
            AND (DECODE(C_NF.IDENTRSAIDOP, 'E', CDCTBLENTREN, CDCTBLSAIDEN) IS  NOT NULL)) LOOP

            IF C_ITEMENCARGO.IDENCARGO = 'A' THEN

               NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, C_ITEMENCARGO.CDCTBLSAIDEN, V_CDHISTPADR, V_DSHISTPADR, C_ITEMENCARGO.VRITEMENCA,
                                V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

               RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, C_ITEMENCARGO.VRITEMENCA);
            ELSE
               NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, C_ITEMENCARGO.CDCTBLSAIDEN, V_CDHISTPADR, V_DSHISTPADR, - C_ITEMENCARGO.VRITEMENCA,
                                V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

               RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, - C_ITEMENCARGO.VRITEMENCA);
            END IF;
      END LOOP;

      FOR C_DESCITEM IN(
        SELECT NVL(ROUND(SUM(VRDESCITEM),2),0) AS VRITEMENCA, CDCTBLENTREN, CDCTBLSAIDEN
          FROM ITEMPRODUTO I,
               (SELECT CDCONTDITEN AS CDCTBLENTREN,
                       CDCONTDITSA AS CDCTBLSAIDEN
                  FROM PARAMCTBL
                 WHERE DECODE('S', 'E', CDCONTDITEN, CDCONTDITSA) IS NOT NULL) E
         WHERE I.CDFILIAL   = C_NF.CDFILIAL
           AND I.NRLANCTONF = C_NF.NRLANCTONF
         GROUP BY CDCTBLENTREN, CDCTBLSAIDEN
        HAVING ROUND(SUM(VRDESCITEM),2) > 0) LOOP

        NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, C_DESCITEM.CDCTBLSAIDEN, V_CDHISTPADR, V_DSHISTPADR, - C_DESCITEM.VRITEMENCA,
                                V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

        RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, - C_DESCITEM.VRITEMENCA);
      END LOOP;

     FOR IMP IN (
         SELECT A.CDIMPOSTO, NVL(ROUND(SUM(A.VRIMPOSTONF),2),0) AS VRIMPOSTONF,
                A.IDTRATIMPO, A.IDIMPORECUP, A.IDACRPRODENTRNF, A.IDTRIMPOSTNF,
                NVL(SUM(VRIMPCARGATRIBI),0) AS VRIMPCARGATRIBI,
                MAX(CDCONTATIV) AS CDCONTATIV, MAX(CDCONTPASS)  AS CDCONTPASS,
                MAX(CDCONTDESP)  AS CDCONTDESP
           FROM (SELECT INF.CDIMPOSTO, VRIMPOSTONF, VRIMPCARGATRIBI, NVL(IDACRPRODENTRNF, 'N') IDACRPRODENTRNF,
                        PF.IDCARACFIS, I.IDIMPORECUP, I.IDTRATIMPO, INF.CDFISCALNF, INF.IDTRIMPOSTNF,
                        CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'A', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCONTATIV,
                        CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'P', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCONTPASS,
                        CONTCTBL_IMPOSTO(I.CDIMPOSTO, 'D', NF.IDENTRSAIDOP, NF.CDTIPOOPER, NF.IDTPIJURNF) CDCONTDESP
                   FROM IMPOSTONF INF, IMPOSTO I, NOTAFISCAL NF, PARAMFILIAL PF
                  WHERE NF.CDFILIAL     = C_NF.CDFILIAL
                    AND NF.NRLANCTONF   = C_NF.NRLANCTONF
                    AND PF.CDFILIAL(+)  = NF.CDFILIRECE
                    AND INF.CDFILIAL    = C_NF.CDFILIAL
                    AND INF.NRLANCTONF  = C_NF.NRLANCTONF
                    AND INF.CDIMPOSTO   = I.CDIMPOSTO
                    AND INF.VRIMPOSTONF > 0
                    AND INF.IDIMPOSTONF IN ('1','4')
                    AND I.IDTIPCONTAB  = 'D') A
          WHERE ((((A.IDIMPORECUP  = 'S' AND A.CDFISCALNF = '1' AND NVL(A.IDCARACFIS,'C') = 'C') OR (A.IDCARACFIS = 'A')) AND (A.CDCONTATIV IS NOT NULL)) OR
                 ((A.IDIMPORECUP <> 'S') AND (A.CDCONTPASS IS NOT NULL)))
          GROUP BY A.CDIMPOSTO, A.IDTRATIMPO,  A.IDIMPORECUP, A.IDACRPRODENTRNF, A.IDTRIMPOSTNF) LOOP

             IF IMP.VRIMPOSTONF > 0 THEN
                IF (C_NF.IDOPERDEVONF <> 'S') THEN
                   BEGIN
                     SELECT MAX(CDIMPOSTO)
                       INTO V_CDIMPOSTRIB
                       FROM IMPOSTO
                      WHERE CDIMPOSTRIB = IMP.CDIMPOSTO;
                   EXCEPTION
                    WHEN NO_DATA_FOUND THEN
                      V_CDIMPOSTRIB := NULL;
                   END;

                   IF (V_CDIMPOSTRIB IS NOT NULL) THEN

                      NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTPASS, V_CDHISTPADR, V_DSHISTPADR, ROUND(IMP.VRIMPOSTONF,2),
                                   V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                      RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, ROUND(IMP.VRIMPOSTONF,2));

                      NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTDESP, V_CDHISTPADR, V_DSHISTPADR, - ROUND(IMP.VRIMPOSTONF),
                                   V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                      RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, - ROUND(IMP.VRIMPOSTONF,2));

                   ELSE
                      IF IMP.IDTRIMPOSTNF IS NOT NULL THEN
                         IF IMP.IDTRIMPOSTNF = 'O' THEN
                            NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTPASS, V_CDHISTPADR, V_DSHISTPADR, ROUND(IMP.VRIMPOSTONF),
                                         V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                            RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST,  ROUND(IMP.VRIMPOSTONF,2));
                         ELSE

                            NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTPASS, V_CDHISTPADR, V_DSHISTPADR, ROUND(IMP.VRIMPOSTONF,2),
                                         V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                            RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, ROUND(IMP.VRIMPOSTONF,2));

                            NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTDESP, V_CDHISTPADR, V_DSHISTPADR, - ROUND(IMP.VRIMPOSTONF),
                                         V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                            RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, - ROUND(IMP.VRIMPOSTONF,2));
                         END IF;
                      ELSE
                         IF (IMP.IDTRATIMPO = 'R') THEN
                            NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTATIV, V_CDHISTPADR, V_DSHISTPADR, - ROUND(IMP.VRIMPOSTONF,2),
                                         V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                            RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, - ROUND(IMP.VRIMPOSTONF,2));
                         ELSE IF (IMP.IDTRATIMPO = 'A') THEN
                                  NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTPASS, V_CDHISTPADR, V_DSHISTPADR, ROUND(IMP.VRIMPOSTONF,2),
                                               V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                                  RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, ROUND(IMP.VRIMPOSTONF,2));
                              ELSE IF (IMP.IDTRATIMPO = 'D') THEN
                                        NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTATIV, V_CDHISTPADR, V_DSHISTPADR, - ROUND(IMP.VRIMPOSTONF,2),
                                                     V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                                        RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, - ROUND(IMP.VRIMPOSTONF,2));
                                    ELSE IF (C_NF.IDORIGDESTNF = 'L') THEN
                                             NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTPASS, V_CDHISTPADR, V_DSHISTPADR, ROUND(IMP.VRIMPOSTONF,2),
                                                          V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                                             RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, ROUND(IMP.VRIMPOSTONF,2));
                                         ELSE IF IMP.VRIMPCARGATRIBI > 0 THEN
                                                 NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, V_CCTBLPASS, V_CDHISTPADR, V_DSHISTPADR, ROUND(IMP.VRIMPCARGATRIBI,2),
                                                              V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                                                 RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, ROUND(IMP.VRIMPCARGATRIBI,2));

                                                 NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, V_CDCCTBLDESP, V_CDHISTPADR, V_DSHISTPADR, - ROUND(IMP.VRIMPCARGATRIBI,2),
                                                              V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                                                 RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, - ROUND(IMP.VRIMPCARGATRIBI,2));
                                              ELSE IF IMP.CDIMPOSTO <> V_CDIMPCARGATRIB THEN
                                                       NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTPASS, V_CDHISTPADR, V_DSHISTPADR, ROUND(IMP.VRIMPOSTONF,2),
                                                                    V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                                                       RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, ROUND(IMP.VRIMPOSTONF,2));

                                                       NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTDESP, V_CDHISTPADR, V_DSHISTPADR, - ROUND(IMP.VRIMPOSTONF,2),
                                                                    V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                                                       RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, - ROUND(IMP.VRIMPOSTONF,2));
                                                   END IF;
                                              END IF;
                                         END IF;
                                    END IF;
                              END IF;
                         END IF;
                      END IF;
                   END IF;

                ELSE
                    BEGIN
                     SELECT MAX(CDIMPOSTO)
                       INTO V_CDIMPOSTRIB
                       FROM IMPOSTO
                      WHERE CDIMPOSTRIB = IMP.CDIMPOSTO;
                    EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                      V_CDIMPOSTRIB := NULL;
                    END;

                    BEGIN
                     SELECT A.CDMODDOCFISC, A.DSMODDOCFISC,
                            A.CDTPREGFISC, N.NRLANCTONF,
                            N.CDFILIAL
                       INTO V_CDMODDOCFISC, V_DSMODDOCFISC,
                            V_CDTPREGFISC, V_NRLANCTONFMOD,
                            V_CDFILIALMOD
                       FROM NOTAFISCAL N, MODDOCFISC A
                      WHERE (N.CDMODDOCFISC = A.CDMODDOCFISC)
                        AND (A.CDTPREGFISC  = '70')
                        AND (N.CDFILIAL     = C_NF.CDFILIAL)
                        AND (N.NRLANCTONF   = C_NF.NRLANCTONF)
                      ORDER BY A.CDMODDOCFISC;
                    EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                      V_CDMODDOCFISC := NULL;
                      V_DSMODDOCFISC := NULL;
                      V_CDTPREGFISC  := NULL;
                      V_NRLANCTONFMOD := NULL;
                      V_CDFILIALMOD := NULL;
                    END;

                    IF (V_CDIMPOSTRIB IS NOT NULL) AND (V_CDMODDOCFISC IS NOT NULL) THEN
                       NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTATIV, V_CDHISTPADR, V_DSHISTPADR, ROUND(IMP.VRIMPOSTONF,2),
                                    V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                       RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, ROUND(IMP.VRIMPOSTONF,2));

                       NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTPASS, V_CDHISTPADR, V_DSHISTPADR, - ROUND(IMP.VRIMPOSTONF,2),
                                    V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                       RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, - ROUND(IMP.VRIMPOSTONF,2));

                       BEGIN
                        SELECT NVL(VRPECREPREST,0)
                          INTO V_VRPECREPREST
                          FROM FILIAL
                         WHERE CDFILIAL = C_NF.CDFILIEMIT;
                       EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                         V_VRPECREPREST := 0;
                       END;

                       IF V_VRPECREPREST > 0 THEN
                          NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTATIV, V_CDHISTPADR, V_DSHISTPADR, - (ROUND(IMP.VRIMPOSTONF,2) * V_VRPECREPREST/100) ,
                                       V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                          RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST,  ROUND(IMP.VRIMPOSTONF,2));

                          NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTPASS, V_CDHISTPADR, V_DSHISTPADR, (ROUND(IMP.VRIMPOSTONF,2) * V_VRPECREPREST/100),
                                       V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                          RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, - ROUND(IMP.VRIMPOSTONF,2));
                       END IF;
                    ELSE IF (IMP.IDTRATIMPO = 'A') AND (IMP.IDACRPRODENTRNF = 'S') THEN
                             NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTATIV, V_CDHISTPADR, V_DSHISTPADR, - ROUND(IMP.VRIMPOSTONF,2),
                                          V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                             RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST,  - ROUND(IMP.VRIMPOSTONF,2));
                         ELSE
                             NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, IMP.CDCONTATIV, V_CDHISTPADR, V_DSHISTPADR, ROUND(IMP.VRIMPOSTONF,2),
                                          V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                             RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, ROUND(IMP.VRIMPOSTONF,2));
                         END IF;
                    END IF;
                END IF;
           END IF;
     END LOOP;

     BEGIN
      SELECT CDTPCTRECEB, CDCLASSFINA
        INTO V_CDTPCTRECEB, V_CDCLASSFINA
        FROM CONTARECEBER
       WHERE CDFILIAL    = C_NF.CDFILIAL
         AND NRLANCTONF  = C_NF.NRLANCTONF
         AND (NRSEQVENREC = '' OR 'T' = 'T')
       ORDER BY CDFILIAL, NRLANCTONF, QTDIASVENREC;
     EXCEPTION
      WHEN NO_DATA_FOUND THEN
       V_CDTPCTRECEB := NULL;
       V_CDCLASSFINA := NULL;
     END;

     FOR C_AJUSTE IN(
         SELECT AJ.DSAJUSTEREC,
                SUM(AJ.VRAJUSTEREC) AS VRAJUSTEREC, TI.IDAJUCTREC,
                TI.CDHISTPADR, TI.CDCONTCTBL
           FROM AJCTRECEBER AJ, TIPOAJRECEBER TI
          WHERE AJ.CDFILIAL = C_NF.CDFILIAL
            AND AJ.NRLANCTONF = C_NF.NRLANCTONF
            AND AJ.CDAJUCTREC = TI.CDAJUCTREC
          GROUP BY AJ.DSAJUSTEREC, TI.IDAJUCTREC,
                   TI.CDHISTPADR, TI.CDCONTCTBL) LOOP

        MONTA_HISTORICO(C_NF.CDFILIAL,C_NF.NRLANCTONF,V_CDHISTPADR,C_NF.NRNOTAFISC,C_NF.DTEMISSAO, '01', '', V_DSHISTPADR);

        IF (C_AJUSTE.IDAJUCTREC = 'D') THEN
            NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, V_STCONTCTBL, C_AJUSTE.CDHISTPADR, V_DSHISTPADR, - C_AJUSTE.VRAJUSTEREC ,
                         V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

            RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST,  - C_AJUSTE.VRAJUSTEREC);

            NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, C_AJUSTE.CDCONTCTBL, C_AJUSTE.CDHISTPADR, V_DSHISTPADR, C_AJUSTE.VRAJUSTEREC,
                         V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

            RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, C_AJUSTE.VRAJUSTEREC);
        ELSE IF (C_AJUSTE.IDAJUCTREC = 'A') THEN
                 NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, V_STCONTCTBL, C_AJUSTE.CDHISTPADR, V_DSHISTPADR, C_AJUSTE.VRAJUSTEREC ,
                              V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                 RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST,  C_AJUSTE.VRAJUSTEREC);

                 NOVA_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE, V_DTCONTABIL, V_NRLANCLOTE, C_AJUSTE.CDCONTCTBL, C_AJUSTE.CDHISTPADR, V_DSHISTPADR, - C_AJUSTE.VRAJUSTEREC,
                              V_IDLANCCOME, V_CDCONTCOME, '01', C_NF.NRNOTAFISC, 'S');

                 RATEIO_PARTIDA(C_NF.CDEMPRESA,V_CDLOTE,V_DTCONTABIL,V_NRLANCLOTE, C_NF.CDFILIEMIT, C_NF.CDCENTCUST, - C_AJUSTE.VRAJUSTEREC);
             END IF;
        END IF;
     END LOOP;
    END IF;

    INSERT INTO RELACNFLANCLOTE
       (CDEMPRESA, CDLOTE, NRLANCLOTE, NRSEQLANLOTE, CDFILIAL, NRLANCTONF)
      VALUES
       (C_NF.CDEMPRESA, V_CDLOTE, V_NRLANCLOTE, '00001', C_NF.CDFILIAL, C_NF.NRLANCTONF);
       
    IF CONFERE_PARTIDA(C_NF.CDEMPRESA, V_CDLOTE, V_NRLANCLOTE,C_NF.DTENTRSAID) THEN
       UPDATE NOTAFISCAL SET IDSTATUSCTBNF = 'C'
        WHERE CDFILIAL = C_NF.CDFILIAL
          AND NRLANCTONF = C_NF.NRLANCTONF;
    ELSE
       UPDATE NOTAFISCAL SET IDSTATUSCTBNF = 'E'
        WHERE CDFILIAL = C_NF.CDFILIAL
          AND NRLANCTONF = C_NF.NRLANCTONF;    
    END IF;      
   END LOOP;
   
   DELETE FROM LISTA
    WHERE NRLISTA = P_NRLISTA;
END;
/

