IF EXISTS (SELECT * FROM sysobjects O, sysusers U
           WHERE
            o.name = 'LIMPEZA_VENDAS'  and
            type = 'P'                        and
            u.uid = o.uid                     and
            u.name = USER)

   DROP PROCEDURE LIMPEZA_VENDAS;
GO

CREATE PROCEDURE LIMPEZA_VENDAS
(
   @P_NRLISTA       VARCHAR,
   @P_DTFINAL       DATETIME,
   @P_DSSISTLIMPEZ  VARCHAR,
   @P_NMOPERLIMPEZ  VARCHAR,
   @P_IDSISTEMA     VARCHAR)
AS
   DECLARE @V_NRORDEM           VARCHAR(03);
   DECLARE @V_DSIP              VARCHAR(50);
   DECLARE @V_DSUSUARIO         VARCHAR(50);
   DECLARE @V_DSRDM             VARCHAR(50);
   DECLARE @V_DSMETODO          VARCHAR(250);
   DECLARE @V_DSOPERADOR        VARCHAR(12);

   DECLARE @V_COUNT_COMMIT      NUMERIC;
   DECLARE @V_NUM_TO_COMMIT     NUMERIC; -- NUMERO UTILIZADO PARA REGULARIZAR A QUANTIDADE DE DMLS PARA O COMMIT.

   DECLARE @V_EXCLUTURCAIXA     NUMERIC;
   DECLARE @V_EXCLUMOVCAIXA     NUMERIC;
   DECLARE @V_EXCLUMOVICLIE     NUMERIC;
   DECLARE @V_EXCLUVENDA        NUMERIC;
   DECLARE @V_EXCLUITEMVENDA    NUMERIC;

   DECLARE @V_TURCAIXA_CDFILIAL    VARCHAR(04);
   DECLARE @V_TURCAIXA_CDCAIXA     VARCHAR(03);
   DECLARE @V_TURCAIXA_DTABERCAIX  DATETIME;

   DECLARE @V_MOVCAIXA_CDFILIAL    VARCHAR(04);
   DECLARE @V_MOVCAIXA_CDCAIXA     VARCHAR(03);
   DECLARE @V_MOVCAIXA_DTABERCAIX  DATETIME;
   DECLARE @V_MOVCAIXA_NRSEQUMOVI  VARCHAR(10);

   DECLARE @V_VENDA_CDFILIAL    VARCHAR(04);
   DECLARE @V_VENDA_CDCAIXA     VARCHAR(03);
   DECLARE @V_VENDA_NRSEQVENDA  VARCHAR(10);

   DECLARE @V_CDFILIAL             VARCHAR(4);

   
   DECLARE @ERR    VARCHAR(100);  

   DECLARE C_LISTA CURSOR FOR
      (SELECT CDLISTA AS CDFILIAL
       FROM LISTA
       WHERE NRLISTA = @P_NRLISTA);

BEGIN

   EXEC WEBTUNNING @V_DSIP, @V_DSUSUARIO, @V_DSRDM, @V_DSMETODO, @V_DSOPERADOR;

   SET @V_NRORDEM = '0';

   UPDATE TRABLIMPEZA
      SET IDSTATUSLIMPEZA = 'A'
    WHERE IDLIMPEZA = @P_IDSISTEMA;

   COMMIT;

   /* TABELA SOLICITA  */
   SET @V_NRORDEM =  RIGHT(REPLICATE('0', 3) + CONVERT(CHAR(3),(CONVERT(INT, @V_NRORDEM)+1)), 3);

   UPDATE TABLIMPEZA
      SET NRORDEMLIMPEZA = @V_NRORDEM
    WHERE IDLIMPEZA = @P_IDSISTEMA
      AND NMTABELALIMP = 'TURCAIXA';

   IF NOT(@@ROWCOUNT > 0) BEGIN
      INSERT INTO TABLIMPEZA
      VALUES
      (@P_IDSISTEMA, 'TURCAIXA', @V_NRORDEM);
   END;

   INSERT INTO TRABPROCLIMPEZA
     (IDLIMPEZA, NMTABELALIMP, IDSITUPROCLIMP)
   VALUES
      (@P_IDSISTEMA, 'TURCAIXA', 'A');

   COMMIT;

   OPEN C_LISTA;
   FETCH NEXT FROM C_LISTA INTO @V_CDFILIAL
   WHILE (@@FETCH_STATUS = 0)
   BEGIN
      DECLARE C_TURCAIXA CURSOR FOR
         SELECT CDFILIAL, CDCAIXA, DTABERCAIX
           FROM TURCAIXA
          WHERE TURCAIXA.DTMOVTURCAIX < @P_DTFINAL
            AND TURCAIXA.CDFILIAL = @V_CDFILIAL

      OPEN C_TURCAIXA
      FETCH NEXT FROM C_TURCAIXA INTO @V_TURCAIXA_CDFILIAL, @V_TURCAIXA_CDCAIXA, @V_TURCAIXA_DTABERCAIX;
      WHILE (@@FETCH_STATUS = 0)
      BEGIN

          DELETE FROM FECHACAIXA
          WHERE CDFILIAL = @V_TURCAIXA_CDFILIAL AND
                CDCAIXA = @V_TURCAIXA_CDCAIXA AND
                DTABERCAIX = @V_TURCAIXA_DTABERCAIX;

          DELETE FROM EXTRATOCONS
          WHERE CDFILIAL = @V_TURCAIXA_CDFILIAL AND
                CDCAIXA = @V_TURCAIXA_CDCAIXA AND
                DTABERCAIX = @V_TURCAIXA_DTABERCAIX;

          DELETE FROM TURCAIXATMP
          WHERE CDFILIAL = @V_TURCAIXA_CDFILIAL AND
                CDCAIXA = @V_TURCAIXA_CDCAIXA AND
                DTABERCAIX = @V_TURCAIXA_DTABERCAIX;

          /*Movimentao do caixa*/
          DECLARE C_MOVCAIXA CURSOR FOR
             SELECT CDFILIAL, CDCAIXA, DTABERCAIX, NRSEQUMOVI
               FROM MOVCAIXA
              WHERE CDFILIAL = @V_TURCAIXA_CDFILIAL AND
                    CDCAIXA = @V_TURCAIXA_CDCAIXA  AND
                    DTABERCAIX = @V_TURCAIXA_DTABERCAIX

          OPEN C_MOVCAIXA
          FETCH NEXT FROM C_MOVCAIXA INTO @V_MOVCAIXA_CDFILIAL, @V_MOVCAIXA_CDCAIXA, @V_MOVCAIXA_DTABERCAIX, @V_MOVCAIXA_NRSEQUMOVI;
          WHILE (@@FETCH_STATUS = 0)
          BEGIN

             /*Movimentao do cliente*/
             DELETE FROM MOVICLIE
             WHERE CDFILIAL = @V_MOVCAIXA_CDFILIAL
               AND CDCAIXA = @V_MOVCAIXA_CDCAIXA
               AND DTABERCAIX = @V_MOVCAIXA_DTABERCAIX
               AND NRSEQUMOVI = @V_MOVCAIXA_NRSEQUMOVI;

             SET @V_EXCLUMOVICLIE = @@ROWCOUNT + @V_EXCLUMOVICLIE;

             DELETE FROM MOVCAIXA
              WHERE CDFILIAL = @V_MOVCAIXA_CDFILIAL
                AND CDCAIXA = @V_MOVCAIXA_CDCAIXA
                AND DTABERCAIX = @V_MOVCAIXA_DTABERCAIX
                AND NRSEQUMOVI = @V_MOVCAIXA_NRSEQUMOVI;

             SET @V_EXCLUMOVCAIXA = @@ROWCOUNT + @V_EXCLUMOVCAIXA;

             FETCH NEXT FROM C_MOVCAIXA INTO @V_MOVCAIXA_CDFILIAL, @V_MOVCAIXA_CDCAIXA, @V_MOVCAIXA_DTABERCAIX, @V_MOVCAIXA_NRSEQUMOVI;
         END;
         CLOSE C_MOVCAIXA;
         DEALLOCATE C_MOVCAIXA;

         DECLARE C_VENDA CURSOR FOR
            SELECT CDFILIAL, CDCAIXA, NRSEQVENDA
              FROM VENDA
             WHERE CDFILIAL = @V_TURCAIXA_CDFILIAL
               AND CDCAIXA = @V_TURCAIXA_CDCAIXA
               AND DTABERTUR = @V_TURCAIXA_DTABERCAIX

         OPEN C_VENDA
         FETCH NEXT FROM C_VENDA INTO @V_VENDA_CDFILIAL, @V_VENDA_CDCAIXA, @V_VENDA_NRSEQVENDA;
         WHILE (@@FETCH_STATUS = 0)
         BEGIN
            /*Movimentao do caixa*/
            DELETE FROM MOVCAIXA
            WHERE CDFILIAL = @V_VENDA_CDFILIAL AND
                  CDCAIXA  = @V_VENDA_CDCAIXA  AND
                  NRSEQVENDA = @V_VENDA_NRSEQVENDA;

            SET @V_EXCLUMOVCAIXA = @@ROWCOUNT + @V_EXCLUMOVCAIXA;

            /*Imposto dos itens */
            DELETE FROM ITVENDAIMPOS
            WHERE CDFILIAL = @V_VENDA_CDFILIAL AND
                  CDCAIXA  = @V_VENDA_CDCAIXA  AND
                  NRSEQVENDA = @V_VENDA_NRSEQVENDA;

            /*Itens da venda*/
            DELETE FROM ITEMVENDA
            WHERE CDFILIAL   = @V_VENDA_CDFILIAL AND
                  CDCAIXA    = @V_VENDA_CDCAIXA  AND
                  NRSEQVENDA = @V_VENDA_NRSEQVENDA;

            SET @V_EXCLUITEMVENDA = @@ROWCOUNT + @V_EXCLUITEMVENDA;

            /*Movimentao do cliente*/
            DELETE FROM MOVICLIE
            WHERE CDFILIAL = @V_VENDA_CDFILIAL AND
                  CDCAIXA  = @V_VENDA_CDCAIXA  AND
                  NRSEQVENDA = @V_VENDA_NRSEQVENDA;

            SET @V_EXCLUMOVICLIE = @@ROWCOUNT + @V_EXCLUMOVICLIE;

            /* PARCELA VENDAS*/
            DELETE FROM PARCELAVENDA
            WHERE CDFILIAL = @V_VENDA_CDFILIAL AND
                  CDCAIXA = @V_VENDA_CDCAIXA  AND
                  NRSEQVENDA = @V_VENDA_NRSEQVENDA;

            DELETE FROM COMPITVENDA
            WHERE CDFILIAL = @V_VENDA_CDFILIAL AND
                  CDCAIXA = @V_VENDA_CDCAIXA  AND
                  NRSEQVENDA = @V_VENDA_NRSEQVENDA;

            /*Itens cancelados*/
            DELETE FROM ITVENDACAN
            WHERE CDFILIAL   = @V_VENDA_CDFILIAL AND
                  CDCAIXA    = @V_VENDA_CDCAIXA  AND
                  NRSEQVENDA = @V_VENDA_NRSEQVENDA;

            DELETE FROM EXTRATOCONS
            WHERE CDFILIAL = @V_VENDA_CDFILIAL AND
                  CDCAIXA = @V_VENDA_CDCAIXA  AND
                  NRSEQVENDA = @V_VENDA_NRSEQVENDA;

            DELETE FROM VENDA
            WHERE CDFILIAL = @V_VENDA_CDFILIAL
              AND CDCAIXA = @V_VENDA_CDCAIXA
              AND NRSEQVENDA = @V_VENDA_NRSEQVENDA;

            SET @V_EXCLUVENDA = @@ROWCOUNT + @V_EXCLUVENDA;

            FETCH NEXT FROM C_VENDA INTO @V_VENDA_CDFILIAL, @V_VENDA_CDCAIXA, @V_VENDA_NRSEQVENDA;
         END;
         CLOSE C_VENDA;
         DEALLOCATE C_VENDA;

          /*Fechamento de caixa */
          DELETE FROM FECHACAIXA
          WHERE CDFILIAL   = @V_TURCAIXA_CDFILIAL AND
                CDCAIXA    = @V_TURCAIXA_CDCAIXA  AND
                DTABERCAIX = @V_TURCAIXA_DTABERCAIX;

          DELETE TURCAIXA
           WHERE CDFILIAL = @V_TURCAIXA_CDFILIAL
             AND CDCAIXA = @V_TURCAIXA_CDCAIXA
             AND DTABERCAIX = @V_TURCAIXA_DTABERCAIX;

          SET @V_EXCLUTURCAIXA = @@ROWCOUNT + @V_EXCLUTURCAIXA;

          IF @V_COUNT_COMMIT >= @V_NUM_TO_COMMIT BEGIN

            UPDATE TRABPROCLIMPEZA
              SET QTREGEXCLIMPEZA = @V_EXCLUTURCAIXA
            WHERE IDLIMPEZA = @P_IDSISTEMA
              AND NMTABELALIMP = 'TURCAIXA';

            SET @V_COUNT_COMMIT= 1;
            COMMIT;
          END
          ELSE BEGIN
            SET @V_COUNT_COMMIT = @V_COUNT_COMMIT + 1;
          END;

         FETCH NEXT FROM C_TURCAIXA INTO @V_TURCAIXA_CDFILIAL, @V_TURCAIXA_CDCAIXA, @V_TURCAIXA_DTABERCAIX;
      END;
      CLOSE C_TURCAIXA;
      DEALLOCATE C_TURCAIXA;

      FETCH NEXT FROM C_LISTA INTO @V_CDFILIAL;
   END;
   CLOSE C_LISTA;
   DEALLOCATE C_LISTA;

   /* COLOCA O STATUS DA TABELA DE LIMPEZA PARA CONCLUIDO */
   UPDATE TRABPROCLIMPEZA
      SET IDSITUPROCLIMP = 'C',
          QTREGEXCLIMPEZA = @V_EXCLUTURCAIXA,
          DTHRFINLIMPEZA = GETDATE()
    WHERE IDLIMPEZA = @P_IDSISTEMA AND
          NMTABELALIMP = 'TURCAIXA';

   /*deleta a tabela temporaria da limpeza */
   DELETE FROM TRABLIMPEZA
   WHERE IDLIMPEZA = @P_IDSISTEMA;

   COMMIT;   

   INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES (@P_DSSISTLIMPEZ, 'TURCAIXA', GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'TURCAIXA', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_EXCLUTURCAIXA);

   INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES (@P_DSSISTLIMPEZ, 'MOVICLIE', GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'MOVICLIE', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_EXCLUMOVICLIE);

   INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES (@P_DSSISTLIMPEZ, 'MOVCAIXA', GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'MOVCAIXA', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_EXCLUMOVCAIXA);

   INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES (@P_DSSISTLIMPEZ, 'VENDA', GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'VENDA', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_EXCLUVENDA);

   INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
   VALUES (@P_DSSISTLIMPEZ, 'ITEMVENDA', GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'ITEMVENDA', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_EXCLUITEMVENDA);

   IF @Err <> 0 BEGIN
      /*deleta a tabela temporaria da limpeza */
      DELETE FROM TRABLIMPEZA
      WHERE IDLIMPEZA = @P_IDSISTEMA;

      IF (@V_EXCLUTURCAIXA = 0) BEGIN
         INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
         VALUES (@P_DSSISTLIMPEZ, 'TURCAIXA', GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'TURCAIXA', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_EXCLUTURCAIXA);
      END;

      IF (@V_EXCLUMOVICLIE = 0) BEGIN
         INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
         VALUES (@P_DSSISTLIMPEZ, 'MOVICLIE', GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'MOVICLIE', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_EXCLUMOVICLIE);
      END;

      IF (@V_EXCLUMOVCAIXA = 0) BEGIN
         INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
         VALUES (@P_DSSISTLIMPEZ, 'MOVCAIXA', GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'MOVCAIXA', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_EXCLUMOVCAIXA);
      END;

      IF (@V_EXCLUVENDA = 0) BEGIN
         INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
         VALUES (@P_DSSISTLIMPEZ, 'VENDA', GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'VENDA', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_EXCLUVENDA);
      END;

      IF (@V_EXCLUITEMVENDA = 0) BEGIN
         INSERT INTO LOGLIMPEZA (DSSISTLIMPEZ, NMTABLIMP, DTLIMPDADOS, NMOPERLIMPEZ, DTFINALIMPEZ, DSLIMPEZA, DSRDMUSULOGL, DSENDUSULOGL, DSNMUSUOLOGL, DSMETUSULOGL, QTDLINHAEXCL)
         VALUES (@P_DSSISTLIMPEZ, 'ITEMVENDA', GETDATE(), @P_NMOPERLIMPEZ, @P_DTFINAL, 'ITEMVENDA', @V_DSRDM, @V_DSIP, @V_DSUSUARIO, @V_DSMETODO, @V_EXCLUITEMVENDA);
      END;

      COMMIT;


      RETURN (@Err)

   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LIMPEZA_VENDAS','5.05.009';
GO

