<?php
namespace Zeedhi\DevOps\Model\Devops\Repositories;

use Doctrine\DBAL\Connection;
use Zeedhi\DevOps\Util\Utilities;
use Zeedhi\DevOps\Model\Configurationmanager\Entities\ProductFiles;
use Zeedhi\DevOps\Util\Utilities as DevOpsUtilities;

class MnemonicGrouping extends \Doctrine\ORM\EntityRepository {

   
    public function findMnemonicGrouping($organizationId, $filters, $limit, $offset){

        $query = <<<SQL
			 SELECT * FROM (
			 SELECT MG.CREATED ,MG.ID, MG.NAME, MG.ORGANIZATION_ID, MG.UPDATED, MG.UPDATED_BY, MG.IS_ACTIVE, ZH.NAME AS UPDATED_NAME, ZH2.NAME AS CREATED_NAME FROM MNEMONIC_GROUPING MG
			 JOIN ZH_USER ZH ON ZH.ID = MG.UPDATED_BY
			 JOIN ZH_USER ZH2 ON ZH2.ID = MG.CREATED_BY

			 WHERE MG.ORGANIZATION_ID = :ORGANIZATION_ID)
			  WHERE 1=1
			 $filters
SQL;
        
         $params = array(
            'ORGANIZATION_ID'=> $organizationId
        );
        $query = DevOpsUtilities::getPaginatedQuery($query, $limit, $offset);
        return $this->getEntityManager()->getConnection()->fetchAll($query, $params);
    }
    
    public function validateIfMnemonicGroupIsInUse($id){
        $query = <<<SQL
			 SELECT MNEMONIC 
                FROM MNEMONIC MNE
                JOIN MNEMONIC_GROUPING MG ON MNE.MNEMONIC_GROUPING_ID = MG.ID
                WHERE MG.ID = $id
                GROUP BY MNEMONIC
SQL;
        
        
        return $this->getEntityManager()->getConnection()->fetchAll($query);
    }

    
    
}